#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef DEBUG
    #define var(x) cerr << #x << ": " << x << '\n';
    #define range(a, b) cerr << #a <<", " << #b << ": "; for (auto _it = a; _it != b; ++_it) cerr << *_it << ' '; cerr <<'\n';
#else
    #define cerr if (false) cerr
    #define var(x)
    #define range(a, b)
#endif

#define double long double

#define pii pair<int, int>
#define F first
#define S second
#define T(x, i) get<i>(x)
#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < n; i++)

const int MAXN = 21;
int n;

int a[MAXN][MAXN];

void solve() {
    forn(i, n) forn(j, n) {
        cin >> a[i][j];
    }
    int K = n;
    double seconds = pow(10, 20);
    set<pair<int, pii>> s;
    map<pii, int> dist;
    dist[{0, 0}] = 0;
    s.insert({0, {0, 0}});
    int DX[4] = {0, -1, 0, 1};
    int DY[4] = {-1, 0, 1, 0};
    auto cost = [&](pii A, pii B) {
        A.F %= n;
        if (A.F < 0) A.F += n;
        A.S %= n;
        if (A.S < 0) A.S += n;
        B.F %= n;
        if (B.F < 0) B.F += n;
        B.S %= n;
        if (B.S < 0) B.S += n;
        return 1 + abs(a[A.F][A.S] - a[B.F][B.S]);
    };
    while (s.size() > 0) {
        auto [d, p] = *s.begin();
        s.erase(s.begin());
        if (p.F > n * K) continue;
        if (p.S > n * K) continue;
        if (p.F <= -n) continue;
        if (p.S <= -n) continue;
        for (int dx = 0; dx < 4; dx++) {
            int nx = p.F + DX[dx];
            int ny = p.S + DY[dx];
            int trying = d + cost(p, {nx, ny});
            if (!dist.count({nx, ny}) || dist[{nx, ny}] > trying) {
                if (nx == n && ny == n) {
                    var(p.F << ' ' << p.S << ' ' << trying);
                }
                dist[{nx, ny}] = trying;
                s.insert({trying, {nx, ny}});
            }
        }
    }
    vector<pair<double, pii>> v;
    cerr << "dists:\n";
    for (int dx = 0; dx <= K; dx++) {
        for (int dy = 0; dy <= K; dy++) {
            cerr << dist[{dx * n, dy * n}] << ' ';
            if (max(dx, dy) < K) continue;
            if (!dist.count({dx * n, dy * n})) continue;
            v.push_back({seconds / dist[{dx * n, dy * n}], {dx, dy}});
        }
        cerr << '\n';
    }
    using pdd = pair<double, double>;
    vector<pair<double, double>> P;
    for (auto [d, p] : v) {
        P.emplace_back(p.F * d, p.S * d);
    }
    P.emplace_back(0, 0);
    sort(all(P), [&](pdd A, pdd B) {
        return make_pair(-A.F, A.S) < make_pair(-B.F, B.S);
    });
    double ans = 0;
    auto cross = [&](pdd A, pdd B) {
        return A.F * B.S - A.S * B.F;
    };
    auto diff = [&](pdd A, pdd B) {
        return make_pair(A.F - B.F, A.S - B.S);
    };
    for (int i = 0; i < P.size(); i++) {
        double cur = cross(P[i], P[(i + 1) % P.size()]);
        ans += cur * 2.0;
    }
    ans = abs(ans);
    ans *= n * n;
    cout << ans << '\n';
}

signed main() {
    #ifdef DEBUG
        freopen("G.in", "r", stdin);
        freopen("output.out", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    while (cin >> n) solve();
}