#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef DEBUG
    #define var(x) cerr << #x << ": " << x << '\n';
    #define range(a, b) cerr << #a <<", " << #b << ": "; for (auto _it = a; _it != b; ++_it) cerr << *_it << ' '; cerr <<'\n';
#else
    #define cerr if (false) cerr
    #define var(x)
    #define range(a, b)
#endif

#define pii pair<int, int>
#define F first
#define S second
#define T(x, i) get<i>(x)
#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < n; i++)

#define int long long

const int MAXN = 1e6 + 10;
int n;


mt19937_64 rng(1033);


void solve() {
    int a, b, s = 0;
    // cin >> a >> b;
    a  = abs((ll)rng()) % (10);
    b  = abs((ll)rng()) % (10);
    n--;

    int non_zeros = 0;
    int max_d = 0;

    vector<int> dd(n);
    forn(i, n) {
        // cin >> dd[i];
        dd[i]  = abs((ll)rng()) % (10);
        s += dd[i];
        if (dd[i] == 0)
            non_zeros++;
        max_d = max(max_d, dd[i]);
    }

    cerr << "test " << n << ' ' << a << ' ' << b << endl;
    range(dd.begin(), dd.end());

    if (s < a + b) {
        cout << "NO\n";
        return;
    }

    if ((s - a - b) % 2 == 1) {
        cout << "NO\n";
        return;
    }

    if ((non_zeros == n - 1) && (s > a + b)) {
        cout << "NO\n";
        return;
    }

    if (max_d - (s - max_d) > (a + b)) {
        cout << "NO\n";
        return;
    }

    vector<pair<int, int>> ans(n);
    vector<int> ord(n);

    forn(i, n) ord[i] = i;

    sort(ord.begin(), ord.end(), [&](int a, int b) {
        return dd[a] > dd[b];
    });

    int d = (s - a - b) / 2;

    int cur_x = 0;
    int cur_y = 0;
    
    cout << "YES\n";
    cout << cur_x << ' ' << cur_y << '\n';

    int stage = 0;

    forn(i, n) {
        int dx = 0;
        int dy = 0;

        int len = dd[ord[i]];

        if (stage == 0) {
            if (cur_x < a) {
                // cerr << "CASE 1" << endl;
                int step = min(a - cur_x, len);
                len -= step;
                cur_x += step;
                dx += step;
            }

            if (cur_y - len < (-d)) {
                // cerr << "CASE 2" << endl;
                int step = (cur_y + d);
                cur_x += step;
                dx += step;
                len -= step;
                cur_y += len;
                dy += len;
                stage = 1;
            } else {
                // cerr << "CASE 3" << endl;
                cur_y -= len;
                dy -= len;
            }
        } else {
            if (cur_x > a) {
                // cerr << "CASE 4" << endl;
                int step = min(cur_x - a, len);
                len -= step;
                cur_x -= step;
                dx -= step;
            }


            // cerr << "CASE 5" << endl;

            cur_y += len;
            dy += len;
        }

        // cout << cur_x << ' ' << cur_y << '\n';
        // cout << cur_x << ' ' << cur_y << endl;

        ans[ord[i]] = {dx, dy};
    }

    cur_x = 0;
    cur_y = 0;

    forn(i, n) {
        int old_x = cur_x;
        int old_y = cur_y;

        cur_x += ans[i].first;
        cur_y += ans[i].second;

        cout << cur_x << ' ' << cur_y << endl;
        assert(abs(cur_x - old_x) + abs(cur_y - old_y) == dd[i]);
    }

    assert(cur_x == a);
    assert(cur_y == b);
}

signed main() {
    #ifdef DEBUG
        freopen("H.in", "r", stdin);
        // freopen("output.out", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    // while (cin >> n) solve();

    for (int i = 0; i < 1000; i++) {
        n = (abs((ll)rng()) % (3)) + 2;
        cerr << "n = " << n << endl;
        solve();

    }


}